package hero.entity;
import hero.interfaces.Constants;
import hero.interfaces.BnEdgeLocal;
import hero.interfaces.BnNodeLocal;

import java.util.*;
import org.apache.log4j.Category;


/*
* 02/01/2002 - 15:24:07
*
* AndEdgeState.java - 
* Copyright (C) 2002 Ecoo Team
* charoy@loria.fr
* 
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

public class AndEdgeState extends EdgeState implements java.io.Serializable {

    private static AndEdgeState nd;
    // Utility variable
    private static final Category log = Category.getInstance(AndEdgeState.class);

    public AndEdgeState() {
    }

    public static AndEdgeState getInstance() {
	if (nd==null) {
	    nd=new AndEdgeState();
	}
	return nd;
    }

    public int state(BnNodeLocal node) {
	Collection edges=node.getInBnEdges();
	log.debug("incoming edges ="+edges.size());
	Iterator i = edges.iterator();
	int result=Constants.Nd.ACTIVE;
	while (i.hasNext()) {
	    BnEdgeLocal edge = (BnEdgeLocal)i.next();
	    log.debug("Computing for edge "+edge.getName());
	    if (edge.getState()==Constants.Ed.INITIAL) {
		result=Constants.Nd.EDGEINITIAL;
		break;
	    }
	    if ((edge.getState() == Constants.Ed.ANTICIPATING))
		result=Constants.Nd.ANTACTIVE;
	    if ((edge.getState() == Constants.Ed.DEAD))
		{
		    result=Constants.Nd.CANCEL;
		    break;
		}	    
	}
	return result;	
    }	   
}











